﻿Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports DayPilot.Web.Mvc
Imports DayPilot.Web.Mvc.Enums
Imports DayPilot.Web.Mvc.Events
Imports DayPilot.Web.Mvc.Events.Month

Namespace MvcApplication1.Controllers

    <HandleError()>
    Public Class MonthController
        Inherits Controller

        Public Function Backend() As ActionResult
            Return New Dpm().CallBack(Me)
        End Function


        Public Class Dpm
            Inherits DayPilotMonth

            Protected Overrides Sub OnTimeRangeSelected(ByVal e As TimeRangeSelectedArgs)
                Dim em = New EventManager(Controller)
                em.EventCreate(e.Start, e.End, "Default name")
                Update()
            End Sub

            Protected Overrides Sub OnEventMove(ByVal e As DayPilot.Web.Mvc.Events.Month.EventMoveArgs)
                Dim em = New EventManager(Controller)
                em.EventMove(e.Id, e.NewStart, e.NewEnd)
                Update()
            End Sub

            Protected Overrides Sub OnEventMenuClick(ByVal e As DayPilot.Web.Mvc.Events.Month.EventMenuClickArgs)
                If e.Command = "Delete" Then
                    Dim em = New EventManager(Controller)
                    em.EventDelete(e.Id)
                    Update()
                End If
            End Sub

            Protected Overrides Sub OnEventResize(ByVal e As DayPilot.Web.Mvc.Events.Month.EventResizeArgs)
                Dim em = New EventManager(Controller)
                em.EventMove(e.Id, e.NewStart, e.NewEnd)
                Update()
            End Sub

            Protected Overrides Sub OnInit(ByVal e As DayPilot.Web.Mvc.Events.Month.InitArgs)
                Update()
            End Sub

            Protected Overrides Sub OnFinish()
                If UpdateType = CallBackUpdateType.None Then
                    Return
                End If

                Dim em = New EventManager(Controller)
                Events = em.FilteredData(VisibleStart, VisibleEnd).AsEnumerable
                DataStartField = "eventstart"
                DataEndField = "eventend"
                DataTextField = "name"
                DataIdField = "id"
            End Sub
        End Class
    End Class


End Namespace
