﻿Imports System
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Mvc
Imports DayPilot.Web.Mvc
Imports DayPilot.Web.Mvc.Enums
Imports DayPilot.Web.Mvc.Events
Imports DayPilot.Web.Mvc.Events.Month
Imports System.Data.SqlClient


Public Class EventManager

    Public Sub New(ByVal controller As Controller)

    End Sub


    Public Function FilteredData(ByVal start As DateTime, ByVal end_ As DateTime) As DataTable
        Dim da As SqlDataAdapter = New SqlDataAdapter("SELECT * FROM [event] WHERE NOT (([eventend] <= @start) OR ([eventstart] >= @end))", ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
        da.SelectCommand.Parameters.AddWithValue("start", start)
        da.SelectCommand.Parameters.AddWithValue("end", end_)

        Dim dt = New DataTable
        da.Fill(dt)
        Return dt

    End Function

    Public Sub EventMove(ByVal id As String, ByVal start As DateTime, ByVal end_ As DateTime)
        Using con As New SqlConnection(ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
            con.Open()

            Dim cmd As SqlCommand = New SqlCommand("UPDATE [event] SET [eventstart] = @start, [eventend] = @end WHERE [id] = @id", con)
            cmd.Parameters.AddWithValue("id", id)
            cmd.Parameters.AddWithValue("start", start)
            cmd.Parameters.AddWithValue("end", end_)
            cmd.ExecuteNonQuery()

        End Using
    End Sub

    Public Sub EventEdit(ByVal id As String, ByVal name As String)
        Using con As New SqlConnection(ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
            con.Open()

            Dim cmd As SqlCommand = New SqlCommand("UPDATE [event] SET [name] = @name WHERE [id] = @id", con)
            cmd.Parameters.AddWithValue("id", id)
            cmd.Parameters.AddWithValue("name", name)
            cmd.ExecuteNonQuery()

        End Using
    End Sub

    Public Sub EventCreate(ByVal start As DateTime, ByVal end_ As DateTime, ByVal text As String)
        Using con As New SqlConnection(ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
            con.Open()

            Dim cmd As SqlCommand = New SqlCommand("INSERT INTO [event] (eventstart, eventend, name) VALUES (@start, @end, @name)", con)
            cmd.Parameters.AddWithValue("start", start)
            cmd.Parameters.AddWithValue("end", end_)
            cmd.Parameters.AddWithValue("name", text)
            cmd.ExecuteNonQuery()

        End Using
    End Sub

    Public Sub EventDelete(ByVal id As String)
        Using con As New SqlConnection(ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
            con.Open()

            Dim cmd As SqlCommand = New SqlCommand("DELETE FROM [event] WHERE id = @id", con)
            cmd.Parameters.AddWithValue("id", id)
            cmd.ExecuteNonQuery()

        End Using
    End Sub

    Public Function Get_(ByVal id As String) As Event_
        Dim da As SqlDataAdapter = New SqlDataAdapter("SELECT * FROM [event] WHERE  id = @id", ConfigurationManager.ConnectionStrings("daypilot").ConnectionString)
        da.SelectCommand.Parameters.AddWithValue("id", id)

        Dim dt = New DataTable
        da.Fill(dt)

        If dt.Rows.Count > 0 Then
            Dim dr = dt.Rows(0)
            Return New Event_ With {
                .Id = id,
                .Text = dr("text"),
                .Start = dr("eventstart"),
                .End_ = dr("eventend")
            }
        End If
        Return Nothing
    End Function


    Public Class Event_
        Public Id As String
        Public Text As String
        Public Start As DateTime
        Public End_ As DateTime
    End Class

End Class
